--*************************************************************************
--  CREACIO TAULA LOG PER EMAGATZEMAR ELS PROCEDIMENTS EXECUTATS
--*************************************************************************

DROP TABLE log CASCADE CONSTRAINTS PURGE;

CREATE TABLE log (
    idLog         NUMBER        CONSTRAINT PK_Log PRIMARY KEY,
    dataHora      TIMESTAMP     CONSTRAINT NN_dataHora NOT NULL,
    procediment   VARCHAR2(50)  CONSTRAINT NN_procediment NOT NULL,
    paramEntrada  VARCHAR2(400) CONSTRAINT NN_paramEntrada NOT NULL,
    paramSortida  VARCHAR2(400) CONSTRAINT NN_paramSortida NOT NULL
    );

DROP SEQUENCE seq_log;

CREATE SEQUENCE seq_log 
      INCREMENT BY 1 
      START WITH 1;

--  Creacio disparador tr_idLog_insert per autonumerar els procediments executats
CREATE OR REPLACE TRIGGER tr_IdLog_insert
      BEFORE INSERT ON log
      FOR EACH ROW
      BEGIN
          SELECT seq_log.NEXTVAL INTO :NEW.idLog FROM DUAL;
          SELECT current_timestamp INTO :NEW.dataHora FROM DUAL;
      END tr_IdLog_insert;
/
COMMIT
/



