CREATE OR REPLACE PROCEDURE  p_cons_votacions_pais(	
	v_idPais IN pais.idPais%TYPE,
        RSP OUT VARCHAR2
        )
IS
        var_procediment VARCHAR2(50) := 'p_cons_votacions_pais';
        var_par_entrada VARCHAR2(400);
        var_linia_llistat VARCHAR2(2000);
        var_numPais NUMBER;
        var_idVotacio votacio.idVotacio%TYPE;
        var_titol votacio.titol%TYPE;
        var_datainici votacio.datainici%TYPE;
        var_datafinal votacio.datafinal%TYPE;
        var_dataPublicacio votacio.datapublicacio%TYPE;
        var_estat votacio.estat%TYPE;
        var_percenparticipacio votacio.percenparticipacio%TYPE;
        var_nPersDretVot NUMBER;
        var_OpcioMesVotada opcionsvotacio%ROWTYPE;
        var_nomOpcio opcio.nom%TYPE;
        var_litEstat VARCHAR2(20);
        e_parmEntrada EXCEPTION;

        -- Cursor de les votacions per pais
        CURSOR c_llistat IS
          SELECT  votacio.idVotacio, votacio.titol, votacio.datainici, 
                  votacio.datafinal, votacio.estat, votacio.percenparticipacio, 
                  votacio.datapublicacio
            FROM pais
              INNER JOIN cens ON (pais.idpais=cens.idpais OR cens.tipus='G')
              INNER JOIN censvotacio ON cens.idcens=censvotacio.idcens
              INNER JOIN votacio ON censvotacio.idVotacio=votacio.idVotacio
            WHERE pais.idPais=v_idPais
            GROUP BY votacio.idVotacio, votacio.titol, votacio.datainici, votacio.datafinal, votacio.estat, votacio.percenparticipacio, votacio.datapublicacio   
            ORDER BY votacio.datainici ASC;        
BEGIN
    var_par_entrada := 'idPais:'||v_idPais;

    -- validaci parametres entrada
    IF v_idPais is null THEN
      RSP := 'ERROR: Es obligatori especificar el pais a consultar.';
      RAISE e_parmEntrada;
    END IF;
    
    SELECT count(*) INTO var_numPais FROM pais WHERE idPais=v_idPais;
    IF var_numPais = 0 THEN
      RSP := 'ERROR: el pais : '||v_idPais||' no existeix.';
      RAISE e_parmEntrada;
    END IF;  
    -- Fi validaci parametres entrada
    -- LListat 
    DBMS_OUTPUT.PUT_LINE ('LLISTAT VOTACIONS QUE S''HAN PRODUIT EN UN PAIS : ');      
    DBMS_OUTPUT.PUT_LINE ('Pais : ' || v_idPais);      

    OPEN c_llistat;
    LOOP
      	FETCH c_llistat
	INTO var_idVotacio, var_titol, var_datainici, var_datafinal, var_estat, var_percenparticipacio, var_dataPublicacio;
	EXIT WHEN c_llistat%notfound;

        SELECT count(*) INTO var_nPersDretVot FROM
              (SELECT padrocens.idciutada from padrocens
                  INNER JOIN censvotacio ON padrocens.idcens=censvotacio.idcens
                  INNER JOIN votacio ON censvotacio.idvotacio=votacio.idvotacio
              WHERE votacio.idvotacio=var_idVotacio
              GROUP BY padrocens.idciutada);
              
        CASE
          WHEN var_Estat='F' THEN
            var_litEstat := 'Finalitzada';
          WHEN sysdate > var_dataFinal THEN
            var_litEstat := 'Tancada';
          WHEN sysdate >= var_datainici AND sysdate <= var_dataFinal THEN
            var_litEstat := 'Oberta';
          WHEN sysdate >= var_dataPublicacio AND sysdate < var_datainici THEN
            var_litEstat := 'Pendent d''Obertura';
          ELSE
            var_litEstat := 'En edici';
        END CASE;

        var_linia_llistat :=  ' Votacio: '|| var_titol || ' '  ||
                              ' Data Inici: ' || var_datainici || ' ' ||
                              ' Data Final: ' || var_datafinal || ' ' ||
                              ' Persones dret a vot: ' || var_nPersDretVot || ' ' ||
                              ' Estat: ' || var_litEstat;

                              
        IF var_estat = 'F' THEN
          SELECT * INTO var_OpcioMesVotada 
            FROM (SELECT * FROM opcionsvotacio WHERE idvotacio=var_idVotacio ORDER BY nnumerovots DESC)
            WHERE rownum=1;
          SELECT nom INTO var_nomOpcio FROM opcio WHERE idOpcio=var_OpcioMesVotada.idOpcio;

          var_linia_llistat := var_linia_llistat || ' % Participacio: ' || var_percenparticipacio || ' ' ||
                                                    ' Opcio guanyadora: ' || var_nomOpcio || ' ' ||
                                                    ' % Vots opcio guanyadora: ' || var_OpcioMesVotada.percenvots; 
        ELSE
          var_linia_llistat := var_linia_llistat || ' % Participacio: - ' ||
                                                    ' Opcio guanyadora: - ' ||
                                                    ' % Vots opcio guanyadora: - '; 
        END IF;

      
        DBMS_OUTPUT.PUT_LINE ( var_linia_llistat );
    END LOOP;
    CLOSE c_llistat;             

    DBMS_OUTPUT.PUT_LINE (' ');      

    -- accio correcte
    RSP := 'OK';
    INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
    COMMIT;
-- control d'excepcions
EXCEPTION
       	-- problemes amb els parametres d'entrada
	WHEN e_parmEntrada THEN
		ROLLBACK;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
       	-- altres errors
	WHEN OTHERS THEN
		ROLLBACK;
                RSP := 'ERROR En la consulta de les votacions del pais: '||SQLERRM;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
END p_cons_Votacions_pais;
/

CREATE OR REPLACE PROCEDURE  p_cons_10_mes_dif(	
        RSP OUT VARCHAR2
        )
IS
        var_procediment VARCHAR2(50) := 'p_cons_10_mes_dif';
        var_par_entrada VARCHAR2(400) := '';
        var_linia_llistat VARCHAR2(2000);
        var_idVotacio votacio.idVotacio%TYPE;
        var_titol votacio.titol%TYPE;
        var_datainici votacio.datainici%TYPE;
        var_datafinal votacio.datafinal%TYPE;
        var_diferPercen NUMBER;
        var_OpcioMesVotada opcionsvotacio%ROWTYPE;
        var_nomOpcio opcio.nom%TYPE;
        var_OpcioMenysVotada opcionsvotacio%ROWTYPE;

        -- Cursor de les votacions per pais
        CURSOR c_llistat IS
          SELECT * FROM
            (SELECT vot.idVotacio, vot.titol, vot.datainici, vot.datafinal,  
                    ((SELECT MAX(percenvots) FROM opcionsvotacio opcvot WHERE opcvot.idvotacio=vot.idVotacio) -
                    (SELECT MIN(percenvots) FROM opcionsvotacio opcvot WHERE opcvot.idvotacio=vot.idVotacio)) AS diferPercen
            FROM votacio vot
            WHERE   ((SELECT MAX(percenvots) FROM opcionsvotacio opcvot WHERE opcvot.idvotacio=vot.idVotacio) -
                    (SELECT MIN(percenvots) FROM opcionsvotacio opcvot WHERE opcvot.idvotacio=vot.idVotacio)) IS NOT NULL
                    AND vot.ESTAT='F'
            ORDER BY  ((SELECT MAX(percenvots) FROM opcionsvotacio opcvot WHERE opcvot.idvotacio=vot.idVotacio) -
                      (SELECT MIN(percenvots) FROM opcionsvotacio opcvot WHERE opcvot.idvotacio=vot.idVotacio)) DESC)
          WHERE ROWNUM<=10;
       
BEGIN
    var_par_entrada := '-';

    -- validaci parametres entrada

    -- Fi validaci parametres entrada
    -- LListat 
    DBMS_OUTPUT.PUT_LINE ('LLISTAT 10 VOTACIONS AMB MES DIFERENCIA % ENTRE OPCIO GUANYADORA I ULTIMA');      
    
    OPEN c_llistat;
    LOOP
      	FETCH c_llistat
	INTO var_idVotacio, var_titol, var_datainici, var_datafinal, var_diferPercen;
	EXIT WHEN c_llistat%notfound;

        var_linia_llistat :=  ' Votacio: '|| var_titol || ' '  ||
                              ' Data Inici: ' || var_datainici || ' ' ||
                              ' Data Final: ' || var_datafinal || ' ';
                              
        SELECT * INTO var_OpcioMesVotada 
          FROM (SELECT * FROM opcionsvotacio WHERE idvotacio=var_idVotacio ORDER BY percenvots DESC)
          WHERE rownum=1;
        SELECT nom INTO var_nomOpcio FROM opcio WHERE idOpcio=var_OpcioMesVotada.idOpcio;

        var_linia_llistat := var_linia_llistat || ' Opcio mes votada: ' || var_nomOpcio || ' ' ||
                                                  ' % Vots: ' || var_OpcioMesVotada.percenvots; 

        SELECT * INTO var_OpcioMenysVotada 
          FROM (SELECT * FROM opcionsvotacio WHERE idvotacio=var_idVotacio ORDER BY percenvots ASC)
          WHERE rownum=1;
        SELECT nom INTO var_nomOpcio FROM opcio WHERE idOpcio=var_OpcioMenysVotada.idOpcio;

        var_linia_llistat := var_linia_llistat || ' Opcio menys votada: ' || var_nomOpcio || ' ' ||
                                                  ' % Vots: ' || var_OpcioMenysVotada.percenvots; 
      
        var_linia_llistat := var_linia_llistat || ' Dif % entre opcions : '|| (var_OpcioMesVotada.percenvots - var_OpcioMenysVotada.percenvots);

        DBMS_OUTPUT.PUT_LINE ( var_linia_llistat );
    END LOOP;
    CLOSE c_llistat;             
    DBMS_OUTPUT.PUT_LINE (' ');      

    -- accio correcte
    RSP := 'OK';
    INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
    COMMIT;
-- control d'excepcions
EXCEPTION
       	-- altres errors
	WHEN OTHERS THEN
		ROLLBACK;
                RSP := 'ERROR En la consulta de les 10 votacions amb mes diferencia: '||SQLERRM;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
END p_cons_10_mes_dif;
/

CREATE OR REPLACE PROCEDURE  p_cons_10_menys_dif(	
        RSP OUT VARCHAR2
        )
IS
        var_procediment VARCHAR2(50) := 'p_cons_10_menys_dif';
        var_par_entrada VARCHAR2(400) := '';
        var_linia_llistat VARCHAR2(2000);
        var_idVotacio votacio.idVotacio%TYPE;
        var_titol votacio.titol%TYPE;
        var_datainici votacio.datainici%TYPE;
        var_datafinal votacio.datafinal%TYPE;
        var_diferPercen NUMBER;
        var_OpcioMesVotada opcionsvotacio%ROWTYPE;
        var_nomOpcio opcio.nom%TYPE;
        var_OpcioMenysVotada opcionsvotacio%ROWTYPE;
        e_parmEntrada EXCEPTION;

        -- Cursor de les votacions per pais
        CURSOR c_llistat IS
          SELECT * FROM
            (SELECT vot.idVotacio, vot.titol, vot.datainici, vot.datafinal,  
                    ((SELECT MAX(percenvots) FROM opcionsvotacio opcvot WHERE opcvot.idvotacio=vot.idVotacio) -
                    (SELECT MIN(percenvots) FROM opcionsvotacio opcvot WHERE opcvot.idvotacio=vot.idVotacio)) AS diferPercen
            FROM votacio vot
            WHERE   ((SELECT MAX(percenvots) FROM opcionsvotacio opcvot WHERE opcvot.idvotacio=vot.idVotacio) -
                    (SELECT MIN(percenvots) FROM opcionsvotacio opcvot WHERE opcvot.idvotacio=vot.idVotacio)) IS NOT NULL
                    AND vot.ESTAT='F'
            ORDER BY  ((SELECT MAX(percenvots) FROM opcionsvotacio opcvot WHERE opcvot.idvotacio=vot.idVotacio) -
                      (SELECT MIN(percenvots) FROM opcionsvotacio opcvot WHERE opcvot.idvotacio=vot.idVotacio)) ASC)
          WHERE ROWNUM<=10;
       
BEGIN
    var_par_entrada := '-';

    -- validaci parametres entrada

    -- Fi validaci parametres entrada
    -- LListat 
    DBMS_OUTPUT.PUT_LINE ('LLISTAT 10 VOTACIONS AMB MENYS DIFERENCIA % ENTRE OPCIO GUANYADORA I ULTIMA');      
    
    OPEN c_llistat;
    LOOP
      	FETCH c_llistat
	INTO var_idVotacio, var_titol, var_datainici, var_datafinal, var_diferPercen;
	EXIT WHEN c_llistat%notfound;

        var_linia_llistat :=  ' Votacio: '|| var_titol || ' '  ||
                              ' Data Inici: ' || var_datainici || ' ' ||
                              ' Data Final: ' || var_datafinal || ' ';
                              
        SELECT * INTO var_OpcioMesVotada 
          FROM (SELECT * FROM opcionsvotacio WHERE idvotacio=var_idVotacio ORDER BY percenvots DESC)
          WHERE rownum=1;
        SELECT nom INTO var_nomOpcio FROM opcio WHERE idOpcio=var_OpcioMesVotada.idOpcio;

        var_linia_llistat := var_linia_llistat || ' Opcio mes votada: ' || var_nomOpcio || ' ' ||
                                                  ' % Vots: ' || var_OpcioMesVotada.percenvots; 

        SELECT * INTO var_OpcioMenysVotada 
          FROM (SELECT * FROM opcionsvotacio WHERE idvotacio=var_idVotacio ORDER BY percenvots ASC)
          WHERE rownum=1;
        SELECT nom INTO var_nomOpcio FROM opcio WHERE idOpcio=var_OpcioMenysVotada.idOpcio;

        var_linia_llistat := var_linia_llistat || ' Opcio menys votada: ' || var_nomOpcio || ' ' ||
                                                  ' % Vots: ' || var_OpcioMenysVotada.percenvots; 
      
        var_linia_llistat := var_linia_llistat || ' Dif % entre opcions : '|| (var_OpcioMesVotada.percenvots - var_OpcioMenysVotada.percenvots);

        DBMS_OUTPUT.PUT_LINE ( var_linia_llistat );
    END LOOP;
    CLOSE c_llistat;             
    DBMS_OUTPUT.PUT_LINE (' ');      

    -- accio correcte
    RSP := 'OK';
    INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
    COMMIT;
-- control d'excepcions
EXCEPTION
       	-- problemes amb els parametres d'entrada
	WHEN e_parmEntrada THEN
		ROLLBACK;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
       	-- altres errors
	WHEN OTHERS THEN
		ROLLBACK;
                RSP := 'ERROR En la consulta de les 10 votacions amb menys diferencia: '||SQLERRM;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
END p_cons_10_menys_dif;
/

CREATE OR REPLACE PROCEDURE  p_cons_censos_ciutada(	
	v_idCiutada IN padrocens.idCiutada%TYPE,
        RSP OUT VARCHAR2
        )
IS
        var_procediment VARCHAR2(50) := 'p_cons_censos_ciutada';
        var_par_entrada VARCHAR2(400);
        var_numCiutada NUMBER;
        var_idCens cens.idcens%TYPE;
        var_tipus cens.tipus%TYPE;
        var_idPais pais.idPais%TYPE;
        var_nompais pais.nom%TYPE;
        var_idRegio regio.idRegio%TYPE;
        var_nomregio regio.nom%TYPE;
        var_idlocalitat localitat.idlocalitat%TYPE;
        var_nomlocalitat localitat.nom%TYPE;
        var_nomTipus VARCHAR2(10);
        e_parmEntrada EXCEPTION;
        
        -- Cursor pels censos del ciutada
        CURSOR c_llistat IS
          SELECT  padrocens.idCens, cens.tipus, 
                  pais.idPais, pais.nom,
                  regio.idRegio, regio.nom,
                  localitat.idLocalitat, localitat.nom
            FROM padrocens 
              INNER JOIN cens ON padrocens.idcens=cens.idcens
              LEFT OUTER JOIN pais ON cens.idpais=pais.idpais
              LEFT OUTER JOIN regio ON cens.idpais=regio.idpais AND cens.idregio=regio.idregio
              LEFT OUTER JOIN localitat ON cens.idpais=localitat.idpais AND cens.idregio=localitat.idregio AND cens.idlocalitat=localitat.idlocalitat
            WHERE padrocens.idCiutada=v_idCiutada
            ORDER BY padrocens.idcens;          

BEGIN
    var_par_entrada := 'idCiutada:'||v_idCiutada;

    -- validaci parametres entrada
    IF v_idCiutada is null THEN
      RSP := 'ERROR: Es obligatori especificar el ciutada a consultar.';
      RAISE e_parmEntrada;
    END IF;
    
    SELECT count(*) INTO var_numCiutada FROM padrocens WHERE idCiutada=v_idCiutada;
    IF var_numCiutada = 0 THEN
      RSP := 'ERROR: el ciutada : '||v_idCiutada||' no esta assignat a cap cens.';
      RAISE e_parmEntrada;
    END IF;  

    -- Fi validaci parametres entrada
    -- LListat 
    DBMS_OUTPUT.PUT_LINE ('LLISTAT DELS CENSOS ALS QUE PERTANY UN CIUTADA');      
    DBMS_OUTPUT.PUT_LINE ('CIUTADA : ' || v_idCiutada);      

    OPEN c_llistat;
    LOOP
      	FETCH c_llistat
	INTO var_idCens, var_tipus, var_idPais, var_nompais, var_idRegio, var_nomregio, var_idlocalitat, var_nomlocalitat;
	EXIT WHEN c_llistat%notfound;
      
        CASE
          WHEN var_tipus='G' THEN
            var_nomTipus := 'Global';
          WHEN var_tipus='E' THEN
            var_nomTipus := 'Estatal';
          WHEN var_tipus='R' THEN
            var_nomTipus := 'Regional';
          ELSE
            var_nomTipus := 'Local';
        END CASE;            
      
        DBMS_OUTPUT.PUT_LINE (' Cens: ' || var_idCens || ' ' ||
                                           var_tipus || ' ' ||
                                           var_nomTipus || ', ' ||
                              ' Pais :' || var_idPais || ' ' ||
                                           var_nompais || ', ' ||
                             ' Regio :' || var_idRegio || ' ' ||
                                           var_nomregio || ', ' ||
                              ' Localitat :' || var_idLocalitat || ' ' ||
                                                var_nomlocalitat );
    END LOOP;
    CLOSE c_llistat;         
    DBMS_OUTPUT.PUT_LINE (' ');      
    
    -- accio correcte
    RSP := 'OK';
    INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
    COMMIT;
-- control d'excepcions
EXCEPTION
       	-- problemes amb els parametres d'entrada
	WHEN e_parmEntrada THEN
		ROLLBACK;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
       	-- altres errors
	WHEN OTHERS THEN
		ROLLBACK;
                RSP := 'ERROR En la consulta dels censos del ciutada: '||SQLERRM;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
END p_cons_censos_ciutada;
/

CREATE OR REPLACE PROCEDURE  p_cons_votacions_ciutada(	
	v_idCiutada IN padrocens.idCiutada%TYPE,
        RSP OUT VARCHAR2
        )
IS
        var_procediment VARCHAR2(50) := 'p_cons_votacions_ciutada';
        var_par_entrada VARCHAR2(400);
        var_linia_llistat VARCHAR2(2000);
        var_numCiutada NUMBER;
        var_idVotacio votacio.idVotacio%TYPE;
        var_titol votacio.titol%TYPE;
        var_HaParticipat NUMBER;
        e_codiNoExistent EXCEPTION;
	PRAGMA EXCEPTION_INIT(e_codiNoExistent, -02291);
        e_parmEntrada EXCEPTION;

        -- Cursor de les votacions del ciutada
        CURSOR c_llistat IS
          SELECT votacio.idVotacio, votacio.titol
          FROM PADROCENS
                INNER JOIN censvotacio ON padrocens.idcens=censvotacio.idcens
                INNER JOIN votacio ON censvotacio.idvotacio=votacio.idvotacio
          WHERE idCiutada=v_idCiutada
          GROUP BY votacio.idVotacio, votacio.titol
          ORDER BY votacio.titol;

BEGIN
    var_par_entrada := 'idCiutada:'||v_idCiutada;

    -- validaci parametres entrada
    IF v_idCiutada is null THEN
      RSP := 'ERROR: Es obligatori especificar el ciutada a consultar.';
      RAISE e_parmEntrada;
    END IF;
    
    SELECT count(*) INTO var_numCiutada FROM padrocens WHERE idCiutada=v_idCiutada;
    IF var_numCiutada = 0 THEN
      RSP := 'ERROR: el ciutada : '||v_idCiutada||' no esta assignat a cap cens.';
      RAISE e_parmEntrada;
    END IF;  
    -- Fi validaci parametres entrada
    -- LListat 
    DBMS_OUTPUT.PUT_LINE ('LLISTAT DE LES VOTACIONS QUE HA PARTICIPAT I LES QUE NO');      
    DBMS_OUTPUT.PUT_LINE ('CIUTADA : ' || v_idCiutada);      

    OPEN c_llistat;
    LOOP
      	FETCH c_llistat
	INTO var_idVotacio, var_titol;
	EXIT WHEN c_llistat%notfound;

        var_linia_llistat :=  ' Votacio: '|| var_titol || ' ';

        var_HaParticipat := 0;
                              
        SELECT count(*) INTO var_HaParticipat
          FROM participacio
          WHERE idvotacio=var_idVotacio AND idCiutada=v_idCiutada;

        IF var_HaParticipat>0 THEN
          var_linia_llistat := var_linia_llistat || ' --> Hi ha participat '; 
        END IF;
      
        DBMS_OUTPUT.PUT_LINE (var_linia_llistat);
        
    END LOOP;
    CLOSE c_llistat;             
    DBMS_OUTPUT.PUT_LINE (' ');      

    -- accio correcte
    RSP := 'OK';
    INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
    COMMIT;
-- control d'excepcions
EXCEPTION
       	-- problemes amb els parametres d'entrada
	WHEN e_parmEntrada THEN
		ROLLBACK;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
       	-- altres errors
	WHEN OTHERS THEN
		ROLLBACK;
                RSP := 'ERROR  En la consulta de les votacions del ciutada: '||SQLERRM;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
END p_cons_votacions_ciutada;
/