CREATE OR REPLACE PROCEDURE  p_stat_votacio_pais_any(	
	v_idPais IN stat_pais_any.idPais%TYPE,
	v_any IN stat_pais_any.exercici%TYPE,
        RSP OUT VARCHAR2
        )
IS
        var_procediment VARCHAR2(50) := 'p_stat_votacio_pais_any';
        var_par_entrada VARCHAR2(400);
        var_numPais NUMBER;
        var_valorStat NUMBER;
        e_parmEntrada EXCEPTION;

BEGIN
    var_par_entrada := 'idPais:'||v_idPais||' Any:'||v_any;

    -- validaci parametres entrada
    CASE
      WHEN v_idPais is null THEN
        RSP := 'ERROR: Es obligatori especificar el pais a consultar.';
        RAISE e_parmEntrada;
      WHEN v_any is null THEN
        RSP := 'ERROR: Es obligatori especificar l''any a consultar.';
        RAISE e_parmEntrada;
      ELSE
        RSP := 'OK';
    END CASE;
    
    SELECT count(*) INTO var_numPais FROM pais WHERE idPais=v_idPais;
    IF var_numPais = 0 THEN
      RSP := 'ERROR: el pais : '||v_idPais||' no existeix.';
      RAISE e_parmEntrada;
    END IF;

    SELECT count(*) INTO var_numPais FROM stat_pais_any WHERE idPais=v_idPais and exercici=v_any;
    IF var_numPais = 0 THEN
      RSP := 'ERROR: el pais : '||v_idPais||' i any : '|| v_any || ' no te dades a consultar.';
      RAISE e_parmEntrada;
    END IF;
    -- Fi validaci parametres entrada

    -- consulta estadistica 
    
    SELECT nvotacionsfi INTO var_valorStat FROM stat_pais_any WHERE  idPais=v_idPais and exercici=v_any;
    
    DBMS_OUTPUT.PUT_LINE ('Pais : ' || v_idPais ||'    Any :'|| v_any ||'   Votacions finalitzades : ' || var_valorStat);      

    -- accio correcte
    RSP := 'OK';
    INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
    COMMIT;
-- control d'excepcions
EXCEPTION
       	-- problemes amb els parametres d'entrada
	WHEN e_parmEntrada THEN
		ROLLBACK;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
       	-- altres errors
	WHEN OTHERS THEN
		ROLLBACK;
                RSP := 'ERROR En la consulta estadistica votacions pais-any: '||SQLERRM;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
END p_stat_votacio_pais_any;
/

CREATE OR REPLACE PROCEDURE  p_stat_participacio_cens_any(	
	v_idcens IN stat_cens_any.idcens%TYPE,
	v_any IN stat_cens_any.exercici%TYPE,
        RSP OUT VARCHAR2
        )
IS
        var_procediment VARCHAR2(50) := 'p_stat_participacio_cens_any';
        var_par_entrada VARCHAR2(400);
        var_numCens NUMBER;
        var_valorStat NUMBER;
        e_parmEntrada EXCEPTION;

BEGIN
    var_par_entrada := 'idCens:'||v_idCens||' Any:'||v_any;

    -- validaci parametres entrada
    CASE
      WHEN v_idCens is null THEN
        RSP := 'ERROR: Es obligatori especificar el cens a consultar.';
        RAISE e_parmEntrada;
      WHEN v_any is null THEN
        RSP := 'ERROR: Es obligatori especificar l''any a consultar.';
        RAISE e_parmEntrada;
      ELSE
        RSP := 'OK';
    END CASE;
    
    SELECT count(*) INTO var_numCens FROM cens WHERE idCens=v_idCens;
    IF var_numCens = 0 THEN
      RSP := 'ERROR: el cens : '||v_idCens||' no existeix.';
      RAISE e_parmEntrada;
    END IF;

    SELECT count(*) INTO var_numCens FROM stat_cens_any WHERE idCens=v_idCens and exercici=v_any;
    IF var_numCens = 0 THEN
      RSP := 'ERROR: el cens : '||v_idCens||' i any : '|| v_any || ' no te dades a consultar.';
      RAISE e_parmEntrada;
    END IF;
    -- Fi validaci parametres entrada

    -- consulta estadistica 
    
    SELECT valormitjapart INTO var_valorStat FROM stat_cens_any WHERE  idCens=v_idCens and exercici=v_any;
    
    DBMS_OUTPUT.PUT_LINE ('Cens : ' || v_idCens ||'    Any :'|| v_any ||'   Valor mitja de participacio (%) : ' || var_valorStat);      

    -- accio correcte
    RSP := 'OK';
    INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
    COMMIT;
-- control d'excepcions
EXCEPTION
       	-- problemes amb els parametres d'entrada
	WHEN e_parmEntrada THEN
		ROLLBACK;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
       	-- altres errors
	WHEN OTHERS THEN
		ROLLBACK;
                RSP := 'ERROR En la consulta estadistica participacio cens-any: '||SQLERRM;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
END p_stat_participacio_cens_any;
/

CREATE OR REPLACE PROCEDURE  p_stat_votacions_cens_any(	
	v_idcens IN stat_cens_any.idcens%TYPE,
	v_any IN stat_cens_any.exercici%TYPE,
        RSP OUT VARCHAR2
        )
IS
        var_procediment VARCHAR2(50) := 'p_stat_votacions_cens_any';
        var_par_entrada VARCHAR2(400);
        var_numCens NUMBER;
        var_valorStat NUMBER;
        e_parmEntrada EXCEPTION;

BEGIN
    var_par_entrada := 'idCens:'||v_idCens||' Any:'||v_any;

    -- validaci parametres entrada
    CASE
      WHEN v_idCens is null THEN
        RSP := 'ERROR: Es obligatori especificar el cens a consultar.';
        RAISE e_parmEntrada;
      WHEN v_any is null THEN
        RSP := 'ERROR: Es obligatori especificar l''any a consultar.';
        RAISE e_parmEntrada;
      ELSE
        RSP := 'OK';
    END CASE;
    
    SELECT count(*) INTO var_numCens FROM cens WHERE idCens=v_idCens;
    IF var_numCens = 0 THEN
      RSP := 'ERROR: el cens : '||v_idCens||' no existeix.';
      RAISE e_parmEntrada;
    END IF;

    SELECT count(*) INTO var_numCens FROM stat_cens_any WHERE idCens=v_idCens and exercici=v_any;
    IF var_numCens = 0 THEN
      RSP := 'ERROR: el cens : '||v_idCens||' i any : '|| v_any || ' no te dades a consultar.';
      RAISE e_parmEntrada;
    END IF;
    -- Fi validaci parametres entrada

    -- consulta estadistica 
    
    SELECT nvotacions INTO var_valorStat FROM stat_cens_any WHERE  idCens=v_idCens and exercici=v_any;
    
    DBMS_OUTPUT.PUT_LINE ('Cens : ' || v_idCens ||'    Any :'|| v_any ||'   Votacions associades : ' || var_valorStat);      

    -- accio correcte
    RSP := 'OK';
    INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
    COMMIT;
-- control d'excepcions
EXCEPTION
       	-- problemes amb els parametres d'entrada
	WHEN e_parmEntrada THEN
		ROLLBACK;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
       	-- altres errors
	WHEN OTHERS THEN
		ROLLBACK;
                RSP := 'ERROR En la consulta estadistica participacio cens-any: '||SQLERRM;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
END p_stat_votacions_cens_any;
/

CREATE OR REPLACE PROCEDURE  p_stat_any_mes_particip(	
	v_any IN stat_any.exercici%TYPE,
        RSP OUT VARCHAR2
        )
IS
        var_procediment VARCHAR2(50) := 'p_stat_any_mes_particip';
        var_par_entrada VARCHAR2(400);
        var_numStat NUMBER;
        var_valorStat NUMBER;
        var_statVotacio votacio.idvotacio%TYPE;
        var_nomVotacio votacio.titol%TYPE;
        e_parmEntrada EXCEPTION;

BEGIN
    var_par_entrada := ' Any:'||v_any;

    -- validaci parametres entrada
    IF v_any is null THEN
        RSP := 'ERROR: Es obligatori especificar l''any a consultar.';
        RAISE e_parmEntrada;
    END IF;
    
    SELECT count(*) INTO var_numStat FROM stat_any WHERE exercici=v_any;
    IF var_numStat = 0 THEN
      RSP := 'ERROR: l''any : '|| v_any || ' no te dades a consultar.';
      RAISE e_parmEntrada;
    END IF;
    -- Fi validaci parametres entrada

    -- consulta estadistica 
    
    SELECT votaciomespart INTO var_statVotacio FROM stat_any WHERE exercici=v_any;

    SELECT titol INTO var_nomVotacio FROM votacio WHERE idVotacio=var_statVotacio;
    
    DBMS_OUTPUT.PUT_LINE ('Any :'|| v_any ||'   Votacio amb mes participacio : ' || var_statVotacio || ' ' || var_nomVotacio);      

    -- accio correcte
    RSP := 'OK';
    INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
    COMMIT;
-- control d'excepcions
EXCEPTION
       	-- problemes amb els parametres d'entrada
	WHEN e_parmEntrada THEN
		ROLLBACK;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
       	-- altres errors
	WHEN OTHERS THEN
		ROLLBACK;
                RSP := 'ERROR En la consulta estadistica mes participacio any: '||SQLERRM;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
END p_stat_any_mes_particip;
/

CREATE OR REPLACE PROCEDURE  p_stat_any_loc_mes_vots(	
	v_any IN stat_any.exercici%TYPE,
        RSP OUT VARCHAR2
        )
IS
        var_procediment VARCHAR2(50) := 'p_stat_any_loc_mes_vots';
        var_par_entrada VARCHAR2(400);
        var_numStat NUMBER;
        var_valorStat NUMBER;
        var_statPais stat_any.paismesvots%TYPE;
        var_statRegio stat_any.regiomesvots%TYPE;
        var_statLocalitat stat_any.localitatmesvots%TYPE;
        var_nomLocalitat localitat.nom%TYPE;
        e_parmEntrada EXCEPTION;

BEGIN
    var_par_entrada := ' Any:'||v_any;

    -- validaci parametres entrada
    IF v_any is null THEN
        RSP := 'ERROR: Es obligatori especificar l''any a consultar.';
        RAISE e_parmEntrada;
    END IF;
    
    SELECT count(*) INTO var_numStat FROM stat_any WHERE exercici=v_any;
    IF var_numStat = 0 THEN
      RSP := 'ERROR: l''any : '|| v_any || ' no te dades a consultar.';
      RAISE e_parmEntrada;
    END IF;
    -- Fi validaci parametres entrada

    -- consulta estadistica 
    
    SELECT paismesvots, regiomesvots, localitatmesvots INTO var_statPais, var_statRegio, var_statLocalitat FROM stat_any WHERE exercici=v_any;

    SELECT nom INTO var_nomLocalitat FROM localitat WHERE idPais= var_statPais AND idRegio=var_statRegio AND idLocalitat=var_statLocalitat;
    
    DBMS_OUTPUT.PUT_LINE ('Any :'|| v_any ||'   Localitat que mes vots han emes : ' || var_statPais || ' ' || var_statRegio || ' ' || var_statLocalitat || ' ' || var_nomLocalitat);      

    -- accio correcte
    RSP := 'OK';
    INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
    COMMIT;
-- control d'excepcions
EXCEPTION
       	-- problemes amb els parametres d'entrada
	WHEN e_parmEntrada THEN
		ROLLBACK;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
       	-- altres errors
	WHEN OTHERS THEN
		ROLLBACK;
                RSP := 'ERROR En la consulta estadistica localitat mes vots-any: '||SQLERRM;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
END p_stat_any_loc_mes_vots;
/

CREATE OR REPLACE PROCEDURE  p_stat_any_ciut_no_vot(	
	v_any IN stat_any.exercici%TYPE,
        RSP OUT VARCHAR2
        )
IS
        var_procediment VARCHAR2(50) := 'p_stat_any_ciut_no_vot';
        var_par_entrada VARCHAR2(400);
        var_numStat NUMBER;
        var_valorStat NUMBER;
        e_parmEntrada EXCEPTION;

BEGIN
    var_par_entrada := ' Any:'||v_any;

    -- validaci parametres entrada
    IF v_any is null THEN
        RSP := 'ERROR: Es obligatori especificar l''any a consultar.';
        RAISE e_parmEntrada;
    END IF;
    
    SELECT count(*) INTO var_numStat FROM stat_any WHERE exercici=v_any;
    IF var_numStat = 0 THEN
      RSP := 'ERROR: l''any : '|| v_any || ' no te dades a consultar.';
      RAISE e_parmEntrada;
    END IF;
    -- Fi validaci parametres entrada

    -- consulta estadistica 
    
    SELECT percenciutnovotat INTO var_valorStat FROM stat_any WHERE exercici=v_any;

    DBMS_OUTPUT.PUT_LINE ('Any :'|| v_any ||'   Ciutadans no han votat (%) : ' || var_valorStat);      

    -- accio correcte
    RSP := 'OK';
    INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
    COMMIT;
-- control d'excepcions
EXCEPTION
       	-- problemes amb els parametres d'entrada
	WHEN e_parmEntrada THEN
		ROLLBACK;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
       	-- altres errors
	WHEN OTHERS THEN
		ROLLBACK;
                RSP := 'ERROR En la consulta estadistica ciutadans no votat-any: '||SQLERRM;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
END p_stat_any_ciut_no_vot;
/

CREATE OR REPLACE PROCEDURE  p_stat_votacio_mes_part(	
        RSP OUT VARCHAR2
        )
IS
        var_procediment VARCHAR2(50) := 'p_stat_votacio_mes_part';
        var_par_entrada VARCHAR2(400);
        var_numStat NUMBER;
        var_valorStat NUMBER;
        var_statVotacio votacio.idvotacio%TYPE;
        var_nomVotacio votacio.titol%TYPE;
        e_parmEntrada EXCEPTION;

BEGIN
    var_par_entrada := ' ';

    -- validaci parametres entrada
    SELECT count(*) INTO var_numStat FROM stat_votacio;
    IF var_numStat = 0 THEN
      RSP := 'ERROR: no hi ha dades estadistiques calculades.';
      RAISE e_parmEntrada;
    END IF;
    -- Fi validaci parametres entrada

    -- consulta estadistica 
    
    SELECT idvotaciomespart INTO var_statVotacio FROM stat_votacio;

    SELECT titol INTO var_nomVotacio FROM votacio WHERE idVotacio=var_statVotacio;
    
    DBMS_OUTPUT.PUT_LINE ('Votacio amb mes participacio : ' || var_statVotacio || ' ' || var_nomVotacio);      

    -- accio correcte
    RSP := 'OK';
    INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
    COMMIT;
-- control d'excepcions
EXCEPTION
       	-- problemes amb els parametres d'entrada
	WHEN e_parmEntrada THEN
		ROLLBACK;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
       	-- altres errors
	WHEN OTHERS THEN
		ROLLBACK;
                RSP := 'ERROR En la consulta estadistica votacio mes participacio: '||SQLERRM;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
END p_stat_votacio_mes_part;
/

CREATE OR REPLACE PROCEDURE  p_stat_votacio_mes_difer(	
        RSP OUT VARCHAR2
        )
IS
        var_procediment VARCHAR2(50) := 'p_stat_votacio_mes_difer';
        var_par_entrada VARCHAR2(400);
        var_numStat NUMBER;
        var_valorStat NUMBER;
        var_statVotacio votacio.idvotacio%TYPE;
        var_nomVotacio votacio.titol%TYPE;
        e_parmEntrada EXCEPTION;

BEGIN
    var_par_entrada := ' ';

    -- validaci parametres entrada
    SELECT count(*) INTO var_numStat FROM stat_votacio;
    IF var_numStat = 0 THEN
      RSP := 'ERROR: no hi ha dades estadistiques calculades.';
      RAISE e_parmEntrada;
    END IF;
    -- Fi validaci parametres entrada

    -- consulta estadistica 
    
    SELECT idvotaciomesdifer INTO var_statVotacio FROM stat_votacio;

    SELECT titol INTO var_nomVotacio FROM votacio WHERE idVotacio=var_statVotacio;
    
    DBMS_OUTPUT.PUT_LINE ('Votacio amb mes diferencia % opcio mes votada i menys : ' || var_statVotacio || ' ' || var_nomVotacio);      

    -- accio correcte
    RSP := 'OK';
    INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
    COMMIT;
-- control d'excepcions
EXCEPTION
       	-- problemes amb els parametres d'entrada
	WHEN e_parmEntrada THEN
		ROLLBACK;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
       	-- altres errors
	WHEN OTHERS THEN
		ROLLBACK;
                RSP := 'ERROR En la consulta estadistica votacio mes diferencia: '||SQLERRM;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
END p_stat_votacio_mes_difer;
/

CREATE OR REPLACE PROCEDURE  p_stat_votacio_menys_difer(	
        RSP OUT VARCHAR2
        )
IS
        var_procediment VARCHAR2(50) := 'p_stat_votacio_menys_difer';
        var_par_entrada VARCHAR2(400);
        var_numStat NUMBER;
        var_valorStat NUMBER;
        var_statVotacio votacio.idvotacio%TYPE;
        var_nomVotacio votacio.titol%TYPE;
        e_parmEntrada EXCEPTION;

BEGIN
    var_par_entrada := ' ';

    -- validaci parametres entrada
    SELECT count(*) INTO var_numStat FROM stat_votacio;
    IF var_numStat = 0 THEN
      RSP := 'ERROR: no hi ha dades estadistiques calculades.';
      RAISE e_parmEntrada;
    END IF;
    -- Fi validaci parametres entrada

    -- consulta estadistica 
    
    SELECT idvotaciomenysdifer INTO var_statVotacio FROM stat_votacio;

    SELECT titol INTO var_nomVotacio FROM votacio WHERE idVotacio=var_statVotacio;
    
    DBMS_OUTPUT.PUT_LINE ('Votacio amb menys diferencia % opcio mes votada i menys : ' || var_statVotacio || ' ' || var_nomVotacio);      

    -- accio correcte
    RSP := 'OK';
    INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
    COMMIT;
-- control d'excepcions
EXCEPTION
       	-- problemes amb els parametres d'entrada
	WHEN e_parmEntrada THEN
		ROLLBACK;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
       	-- altres errors
	WHEN OTHERS THEN
		ROLLBACK;
                RSP := 'ERROR En la consulta estadistica votacio menys diferencia: '||SQLERRM;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
END p_stat_votacio_menys_difer;
/

CREATE OR REPLACE PROCEDURE  p_stat_max_votacions_persona(	
        RSP OUT VARCHAR2
        )
IS
        var_procediment VARCHAR2(50) := 'p_stat_max_votacions_persona';
        var_par_entrada VARCHAR2(400);
        var_numStat NUMBER;
        var_valorStat NUMBER;
        var_statPais pais.idPais%TYPE;
        var_nomPais pais.nom%TYPE;
        e_parmEntrada EXCEPTION;

BEGIN
    var_par_entrada := ' ';

    -- validaci parametres entrada
    SELECT count(*) INTO var_numStat FROM stat_votacio;
    IF var_numStat = 0 THEN
      RSP := 'ERROR: no hi ha dades estadistiques calculades.';
      RAISE e_parmEntrada;
    END IF;
    -- Fi validaci parametres entrada

    -- consulta estadistica 
    
    SELECT nmaxvotacionspersona, paispersmaxvots INTO var_valorStat, var_statPais FROM stat_votacio;

    SELECT nom INTO var_nomPais FROM pais WHERE idPais=var_statPais;
    
    DBMS_OUTPUT.PUT_LINE ('Numero maxim de votacions que ha participat una persona : ' || var_valorStat || ' Pais: ' || var_nomPais);      

    -- accio correcte
    RSP := 'OK';
    INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
    COMMIT;
-- control d'excepcions
EXCEPTION
       	-- problemes amb els parametres d'entrada
	WHEN e_parmEntrada THEN
		ROLLBACK;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
       	-- altres errors
	WHEN OTHERS THEN
		ROLLBACK;
                RSP := 'ERROR En la consulta estadistica maxim votacio que ha participat persona: '||SQLERRM;
                INSERT INTO log(procediment, paramentrada, paramsortida) VALUES ( var_procediment, var_par_entrada, RSP);
		COMMIT;
END p_stat_max_votacions_persona;
/
